/// Identifier for the type of Forge
#[derive(
    Clone,
    Default,
    Debug,
    derive_more::From,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    serde::Serialize,
    serde::Deserialize,
    Copy,
)]
pub enum ForgeType {
    #[cfg(feature = "forgejo")]
    ForgeJo,
    // Gitea,
    #[cfg(feature = "github")]
    GitHub,
    // GitLab,
    // BitBucket,
    #[default]
    MockForge,
}
impl std::fmt::Display for ForgeType {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(f, "{self:?}")
    }
}
