use std::path::PathBuf;

pub struct GitExec {
    pub exec: String,
    pub git_dir: PathBuf,
}
impl GitExec {
    pub fn exec(self) -> crate::Result<()> {
        gix::command::prepare(format!("/usr/bin/git {}", self.exec))
            .with_context(gix::diff::command::Context {
                git_dir: Some(self.git_dir),
                ..Default::default()
            })
            .with_shell_allow_manual_argument_splitting()
            .stdout(std::process::Stdio::null())
            .stderr(std::process::Stdio::null())
            .spawn()?
            .wait()?;
        Ok(())
    }
}
