//
/// spawns a new actor and sets up bi-directional links
#[macro_export]
macro_rules! spawn {
    ($parent:expr, $actor:expr) => {{
        tracing::debug!("spawning : {}", stringify!($actor));
        let new_actor_ref = kameo::spawn($actor);
        new_actor_ref.link(&$parent).await;
        $parent.link(&new_actor_ref).await;
        tracing::debug!("spawned  : {}", stringify!($actor));
        new_actor_ref
    }};
}

#[macro_export]
macro_rules! spawn_in_thread {
    ($parent:expr, $actor:expr) => {{
        tracing::debug!("spawning in thread : {}", stringify!($actor));
        let new_actor_ref = kameo::actor::spawn_in_thread($actor);
        new_actor_ref.link(&$parent).await;
        $parent.link(&new_actor_ref).await;
        tracing::debug!("spawned  in thread : {}", stringify!($actor));
        new_actor_ref
    }};
}
