//
use kameo::message::{Context, Message};

use crate::{
    publish,
    server::{actor::messages::ServerUpdate, ServerActor},
};

impl Message<ServerUpdate> for ServerActor {
    type Reply = color_eyre::Result<()>;

    async fn handle(
        &mut self,
        msg: ServerUpdate,
        _ctx: &mut Context<Self, Self::Reply>,
    ) -> Self::Reply {
        publish!("server_updates_bus", self.server_updates_bus, msg)?;
        Ok(())
    }
}
