use std::time::Duration;

use color_eyre::Result;
use kameo::message::{Context, Message};

use crate::{
    tell,
    tui::actor::{messages::Tick, Tui},
    IoSendError,
};

impl Message<Tick> for Tui {
    type Reply = Result<(), IoSendError>;

    async fn handle(&mut self, _msg: Tick, ctx: &mut Context<Self, Self::Reply>) -> Self::Reply {
        self.state.tap();
        self.draw()?;
        self.handle_input(&ctx.actor_ref())?;

        tokio::time::sleep(Duration::from_millis(16)).await;
        tell!(ctx.actor_ref(), Tick)?;

        Ok(())
    }
}
