//
use crate::core::ForgeAlias;
use ratatui::{buffer::Buffer, layout::Rect, text::Text, widgets::Widget};

use crate::tui::components::HeightContraintLength;

pub struct CollapsedForgeWidget<'a> {
    pub forge_alias: &'a ForgeAlias,
}
impl HeightContraintLength for CollapsedForgeWidget<'_> {
    fn height_constraint_length(&self) -> u16 {
        1
    }
}
impl Widget for CollapsedForgeWidget<'_> {
    fn render(self, area: Rect, buf: &mut Buffer)
    where
        Self: Sized,
    {
        Text::from(format!("- {}", self.forge_alias)).render(area, buf);
    }
}
