mod data_state;
mod repo_key;
mod repo_state;
mod ui_focus;
mod ui_state;

pub use data_state::DataState;
pub use repo_key::RepoKey;
pub use repo_state::CIStatus;
pub use repo_state::RepoState;
pub use repo_state::RepoStateStatus;
pub use ui_focus::UiFocus;
pub use ui_state::UiState;

#[derive(Debug, Default)]
pub struct XuiState {
    pub data: DataState,
    pub ui: UiState,
}
impl XuiState {
    pub fn selected_repo_state(&self) -> Option<&RepoState> {
        self.ui
            .table_state()
            .selected()
            .and_then(|index| self.data.repos().get(index).copied())
            .map(|(_, repo_state)| repo_state)
    }

    pub fn selected_repo_actor(&self) -> Option<&kameo::actor::ActorRef<crate::repo::RepoActor>> {
        self.selected_repo_state()
            .and_then(|repo_state| repo_state.repo_actor())
    }
}
