use std::fmt::Display;

use bon::Builder;

use crate::core::{ForgeAlias, RepoAlias};

#[derive(Builder, Clone, Debug, Hash, PartialOrd, Ord, PartialEq, Eq)]
pub struct RepoKey {
    forge_alias: ForgeAlias,
    repo_alias: RepoAlias,
}
impl RepoKey {
    pub const fn forge_alias(&self) -> &ForgeAlias {
        &self.forge_alias
    }

    pub const fn repo_alias(&self) -> &RepoAlias {
        &self.repo_alias
    }
}
impl Display for RepoKey {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(f, "{}/{}", self.forge_alias, self.repo_alias)
    }
}
