use bon::Builder;
use ratatui::widgets::TableState;
use tui_scrollview::ScrollViewState;

use super::UiFocus;

#[derive(Builder, Debug, Default)]
pub struct UiState {
    scroll_view_state: ScrollViewState,
    focus: UiFocus,
    filter: String,
    table_state: TableState,
}
impl UiState {
    pub const fn scroll_view_state(&self) -> &ScrollViewState {
        &self.scroll_view_state
    }

    pub fn scroll_view_state_mut(&mut self) -> &mut ScrollViewState {
        &mut self.scroll_view_state
    }

    pub const fn focus(&self) -> &UiFocus {
        &self.focus
    }

    pub fn filter(&self) -> &str {
        &self.filter
    }

    pub fn filter_mut(&mut self) -> &mut String {
        &mut self.filter
    }

    pub const fn table_state(&self) -> &TableState {
        &self.table_state
    }

    pub fn table_state_mut(&mut self) -> &mut TableState {
        &mut self.table_state
    }

    pub fn set_focus(&mut self, ui_focus: UiFocus) {
        self.focus = ui_focus;
    }
}
