use crossterm::event::{KeyCode, KeyEvent};

use crate::{
    repo::messages::RebaseDevOnMain,
    tell,
    xui::state::{UiFocus, XuiState},
    Result,
};

pub async fn handle_dev_rebase_key_event(key_event: KeyEvent, state: &mut XuiState) -> Result<()> {
    if let Some(repo_actor) = state.selected_repo_actor() {
        match key_event.code {
            KeyCode::Enter | KeyCode::Char('y' | 'Y') => tell!(repo_actor, RebaseDevOnMain)?,
            KeyCode::Esc | KeyCode::Char('n' | 'N') => {
                state.ui.set_focus(UiFocus::RepoList);
            }
            _ => {}
        }
    }

    Ok(())
}
