use crossterm::event::{KeyCode, KeyEvent};

use crate::{
    s,
    xui::state::{UiFocus, UiState},
};

pub fn handle_filter_input_key_event(key_event: KeyEvent, ui_state: &mut UiState) {
    match key_event.code {
        KeyCode::Char(char) => {
            ui_state.filter_mut().push(char);
        }
        KeyCode::Backspace => {
            ui_state.filter_mut().pop();
        }
        KeyCode::Tab | KeyCode::Enter => {
            ui_state.set_focus(UiFocus::RepoList);
        }
        KeyCode::Esc => {
            ui_state.set_focus(UiFocus::RepoList);
            *ui_state.filter_mut() = s!("");
        }
        _ => {}
    }
}
