//
use derive_more::{Display, From};

/// Represents a error accessing the file system or network.
#[derive(Debug, From, Display)]
pub enum Error {
    Fs(#[from] crate::fs::Error),
    Net(#[from] crate::net::Error),
    Reqwest(#[from] reqwest::Error),
}
impl std::error::Error for Error {}

/// Represents a success or a failure using `fs` or `net`.
pub type Result<T> = core::result::Result<T, Error>;
